Index: external/fastjet/tools/Filter.cc
===================================================================
--- external/fastjet/tools/Filter.cc	(revision 406b698c06fe4f407ae1b22d74541e35189553af)
+++ external/fastjet/tools/Filter.cc	(revision ce4b888efd02ab0d77f4c22164e7f96245ed8b6a)
@@ -1,4 +1,4 @@
 //FJSTARTHEADER
-// $Id: Filter.cc 3633 2014-08-15 13:23:52Z soyez $
+// $Id: Filter.cc 3760 2014-12-19 10:05:10Z soyez $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -164,6 +164,6 @@
   if ((ca_optimisation_used) && (kept.size()+rejected.size()>0)){
     bool has_non_explicit_ghost_area = (kept.size()>0)
-      ? (kept[0].has_area()     && kept[0].validated_csab()->has_explicit_ghosts())
-      : (rejected[0].has_area() && rejected[0].validated_csab()->has_explicit_ghosts());
+      ? (kept[0].has_area()     && (!(kept[0].validated_csab()->has_explicit_ghosts())))
+      : (rejected[0].has_area() && (!(rejected[0].validated_csab()->has_explicit_ghosts())));
     if (has_non_explicit_ghost_area)
       fs->discard_area();
Index: external/fastjet/tools/GridMedianBackgroundEstimator.hh
===================================================================
--- external/fastjet/tools/GridMedianBackgroundEstimator.hh	(revision 406b698c06fe4f407ae1b22d74541e35189553af)
+++ external/fastjet/tools/GridMedianBackgroundEstimator.hh	(revision ce4b888efd02ab0d77f4c22164e7f96245ed8b6a)
@@ -3,5 +3,5 @@
 
 //FJSTARTHEADER
-// $Id: GridMedianBackgroundEstimator.hh 3610 2014-08-13 09:49:28Z salam $
+// $Id: GridMedianBackgroundEstimator.hh 3778 2014-12-24 09:28:09Z salam $
 //
 // Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -77,5 +77,5 @@
 class GridMedianBackgroundEstimator : public BackgroundEstimatorBase
 #ifdef FASTJET_GMBGE_USEFJGRID
-                                                                    , public RectangularGrid
+                                    , public RectangularGrid
 #endif 
 {
@@ -94,10 +94,22 @@
     _has_particles(false), _enable_rho_m(true) {} 
 
-  /// ctor with more control over initialisation
+  //----------------------------------------------------------------
+  /// Constructor based on a user's fully specified RectangularGrid
+  GridMedianBackgroundEstimator(const RectangularGrid & grid) :
+    RectangularGrid(grid),
+    _has_particles(false), _enable_rho_m(true) {
+    if (!RectangularGrid::is_initialised()) 
+      throw Error("attempt to construct GridMedianBackgroundEstimator with uninitialised RectangularGrid");
+  }    
+
+  //---------------------------------------------------------------- 
+  /// Constructor with the explicit parameters for the underlying
+  /// RectangularGrid
+  ///
   ///  \param rapmin         the minimum rapidity extent of the grid
   ///  \param rapmax         the maximum rapidity extent of the grid
   ///  \param drap           the grid spacing in rapidity
   ///  \param dphi           the grid spacing in azimuth
-  ///  \param tile_selector  optional (geometric) selector to specify
+  ///  \param tile_selector  optional (geometric) selector to specify 
   ///                        which tiles are good; a tile is good if
   ///                        a massless 4-vector at the center of the tile passes
@@ -107,13 +119,4 @@
     RectangularGrid(rapmin_in, rapmax_in, drap_in, dphi_in, tile_selector),
     _has_particles(false), _enable_rho_m(true) {}
-
-  //----------------------------------------------------------------
-  /// Constructor based on a user's fully specified RectangularGrid
-  GridMedianBackgroundEstimator(const RectangularGrid & grid) :
-    RectangularGrid(grid),
-    _has_particles(false), _enable_rho_m(true) {
-    if (!RectangularGrid::is_initialised()) 
-      throw Error("attempt to construct GridMedianBackgroundEstimator with uninitialised RectangularGrid");
-  }    
 
 #else  // alternative in old framework where we didn't have the rectangular grid
Index: external/fastjet/tools/Recluster.hh
===================================================================
--- external/fastjet/tools/Recluster.hh	(revision 406b698c06fe4f407ae1b22d74541e35189553af)
+++ external/fastjet/tools/Recluster.hh	(revision ce4b888efd02ab0d77f4c22164e7f96245ed8b6a)
@@ -2,5 +2,5 @@
 #define __FASTJET_TOOLS_RECLUSTER_HH__
 
-// $Id: Recluster.hh 3714 2014-09-30 09:47:31Z soyez $
+// $Id: Recluster.hh 3760 2014-12-19 10:05:10Z soyez $
 //
 // Copyright (c) 2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
@@ -50,5 +50,5 @@
 /// Alternatively, Recluster can be constructed from a jet algorithm
 /// and an optional radius. In that case the recombiner is
-/// systematically obtained fromn the jet being processed (unless you
+/// systematically obtained from the jet being processed (unless you
 /// call set_acquire_recombiner(false)). If only the jet algorithm is
 /// specified, a default radius of max_allowable_R will be assumed if
@@ -124,5 +124,5 @@
   /// parameter (like the genkt algorithm), please specify the jet
   /// definition fully using the constructor above.
-  Recluster(JetAlgorithm snew_jet_alg, double new_jet_radius, Keep keep_in = keep_only_hardest);
+  Recluster(JetAlgorithm new_jet_alg, double new_jet_radius, Keep keep_in = keep_only_hardest);
 
   /// constructor with just a jet algorithm, but no jet radius. If the
